$MOD52
$TITLE(BYTE SIGNED MULTIPLY)
$PAGEWIDTH(132)
$DEBUG
$OBJECT
$NOPAGING


;--------------Rutina displeje-------------

	ORG 00H
	SJMP start
	ORG 03H		;preruseni INT0 - externi 
	LJMP rtc
	ORG 0BH		;preruseni od citace/casovace 0
	LJMP cit
	ORG 13H
	LJMP int_01	;preruseni INT1 - externi
	ORG 1BH
	LJMP cit_01	;preruseni od citace/casovace 1
	ORG 23H
	LJMP wav

;-------------Deklarace adresoveho prostoru--------------
	schov_6	equ	2DH	;promenne vyuzite v citaci paliva pro bezkonfliktni ukladani dat v INT
	schov_7	equ	2EH	;
	schov_8	equ	2FH	;
	vvys	equ	30H		;pomocny byte pro subrutinu deleni
	vys	equ	31H		;nejvyssi byte delence
	str	equ	32H		;stredni  --//--
	niz	equ	33H		;nizsi --//--
	nejniz	equ	34H		;nejnizsi  --//--
	vys_1	equ	35H		;vyssi byte delitele
	str_1	equ	36H		;stredni byte delitele
	niz_1	equ	37H		;nizsi    --//--
	schov_1	equ	38H		;odlozeni mezivysledku 1.byte
	schov_2	equ	39H		;       --//--	2.byte
	schov_3	equ	3AH		;      --//--   3.byte
	schov_4	equ	3BH		;	--//--  4.byte
	schov_5	equ	3CH		;	--//--	5.byte
	pocpos	equ 	3DH		;pocet posuvu v rutine deleni
	bcd_1	equ	3EH		;vysledek prevodu HEXA -> BCD nizsi byte
	bcd_2	equ	3FH		;      --------//------       vyssi byte
	bcd_3	equ	40H		;      --------//------	   nejvyssi byte	
	vahy_1	equ	41H		;byty pouzite pri prevodu HEXA -> BCD - vahy(nejnizsi)
	vahy_2	equ	42H		;----------//---------	stredni
	vahy_3	equ	43H		;----------//---------  nejvyssi
	pocpos_01	equ	44H	;pocet posuvu v rutine prevodu HEX -> BCD
	nasob_1	equ	45H		;byty rutiny nasobeni - nizsi byte nasobeneho cisla
	nasob_2	equ	46H		;stredni byte nasobeneho cisla
	nasob_3	equ	47H		;vyssi byte nasobeneho cisla
	nasob_4	equ	48H		;jednobytove cislo,kterym je nasobeno
	nasob_5	equ	49H		;vysledek nasobeni-nizsi byte	
	nasob_6	equ	4AH		;vysledek nasobeni-stredni byte
	nasob_7	equ	4BH		;vysledek nasobeni-vyssi byte
	nasob_8	equ	4CH		;vysledek nasobeni-nejvyssi byte
	hex_1	equ	4DH		;vstupni promenne prevodu HEX -> BCD - nizsi byte
	hex_2	equ	4EH		;--------//--------		stredni byte
	hex_3	equ	4FH		;--------//--------		vyssi byte
	minuty	equ	50H		;minuty realtimu
	hodiny	equ	51H		;hodiny realtimu
	anody   equ     52H     	;adresa poctu anod
	tecka   equ     53H     	;dle obsahu rozsvit tecku u odpovidajiciho disp.
	fce     equ     54H     	;byte pro oznaceni prave zobrazovane funkce procesoru 
	dis     equ     55H     	;prvni ze dvou byte s cisly pro displej
;	dis+1	equ	56H		;druhy byte-nechat strednik protoze tento byte jako takovy nema prideleno navesti,ale pouziva se
					;v programu dis a dis+1 !!!
	katody	equ	57H		;byte katod
	nast		equ	58H	;v tomto bytu je po vstupu do editu cislo,ktere se bude pricitat nebo odecitat dle navolene fce
	ttlac		equ	59H	;byte pro mereni doby stisknuti tlacitka MODE pro volbu MODE/ENTER
	vt_prov	equ	5AH	;byte provozniho casu (vteriny)
	min_prov	equ	5BH	;byte provozniho casu (minuty)
	hod_prov	equ	5CH	;byte provozniho casu (hodiny)
	cit_kmh		equ	5DH	;byte mereni ms pro okamzitou rychlost
	vysl_1   	equ     5EH	;vysledek mereni delky impulsu na vstupu INT0-nizsi byte
	vysl_2   	equ     5FH	;vysledek mereni delky impulsu na vstupu INT0-vyssi byte
	vysl_3   	equ     60H	;byte pseudo-nejvyssi-->zavedev softwarove
	drh_1		equ	61H	;nejnizsi byte drahy
	drh_2		equ	62H	;stredni byte drahy
	drh_3		equ	63H	;nejvyssi byte drahy
	vysl_10		equ	64H	;vysledek mereni delky impulsu na vstupu INT1-nizsi byte 
	vysl_20		equ	65H	;vysledek mereni delky impulsu na vstupu INT1-vyssi byte
	vysl_30		equ	66H	;vysledek mereni delky impulsu na vstupu INT1-nejvyssi byte(pseudocitac soft.)
	cit_pal0	equ	67H	;citac paliva-po 150 impulsech t.j. 0,01l
	cit_pal1	equ	68H	;citac paliva-nizsi byte
	cit_pal2	equ	69H	;citac paliva-stredni byte
	cit_pal3	equ	6AH	;citac paliva-vyssi byte
	mezi_1		equ	6BH	;byte slouzici pro uschovani obsahu registru R0 pri jeho pouziti v INT
	cit_pal10	equ	6CH	;3 bytovy citac paliva pro potrebu prumerne spotreby	
	cit_pal20	equ	6DH	;------------//---------------
	cit_pal30	equ	6EH	;------------//---------------
	uloz_1		equ	6FH	;byty obsahujici jednotlive cifry po vymaskovani
	uloz_2		equ	70H
	uloz_3		equ	71H
	uloz_4		equ	72H
	pretec_up	equ	73H	;byte v nemz je nacteno preteceni dane fce (up)
	pretec_down	equ	74H	;byte v nemz je nacteno preteceni dane fce (down)
	DP_H		equ	75H	;ulozeni obsahu DPTR pri vstupu do INT od serioveho kanalu
	DP_L		equ	76H	
	wav_start_hi	equ	77h
	wav_start_lo	equ	wav_start_hi+1
	wav_end_hi	equ	wav_start_lo+1
	wav_end_lo	equ	wav_end_hi+1
	wav_temp	equ	wav_end_lo+1
	dat_logo	equ	7CH			;byte pro uschovani data dne pred vypnutim(pro porovnani dne pro uvodni zpravu)



;----------Bitova oblast-----------
;				       Po resetu    	
	blik_bit0	BIT	00H	;1\	 bit je vybaven v preruseni po 1s - urcen pro blikani cisel v editaci
	edit		BIT	01H	;0 |	 po nastaveni tohoto bitu se spousti rutiny pro editovani
	pozedi		BIT	02H	;0 |	 pokud je bit aktivni je v nastavene funkci mozno editovat
	up_bit		BIT	03H	;0 |=20H pokud je bit aktivni je spustena rutina inkrementace cifry
	down_bit	BIT	04H	;0 |	 pokud je bit aktivni je spustena rutina dekrementace cifry
	pom_bit		BIT	05H	;0 |	 bit pro rutinu prumerene spotreby slouzici k rozdeleni rutiny na dvakrat z duvodu delky rutiny
	jednicky	BIT	06H	;0 |	 bit pro pozadavek editace dalsi cifry (pri nastaveni tohoto bitu pri editu posledni cifry nasleduje vystup z editace)
	nul_bit		BIT	07H	;0/	 bit nulovani dane funkce
	int_bit 	BIT     08H	;0\	 bit indikujici druhe mereni-je-li nastaven probiha ulozeni stejnych udaju na jinou adresu(tyka se INT0)
	uprav_bit 	BIT	09H	;0 |	 pomocny bit pro test vynulovani nejvyssiho bytu vysledku
	int1_bit	BIT	0AH	;0 |	 stejny vyznam jako int_bit,ale tyka se INT1		
	rezpal_bit	BIT	0BH	;0 |=21H priznak indikujici dosazeni rezervy paliva
	nul_draha	BIT	0CH	;1 |	 priznak indikujici stojici vozidlo (nulovy cas od snimace drahy)-pro prepnuti okamzite spotreby na motohodiny
	obeh_bit	BIT	0DH	;0 |	 priznak pro test dis-nastaven,jde o dis+1,jinak dis
	zpomal_0	BIT	0EH	;0 |	 priznaky pro testovani zpozdeni v subrutinach UP/DOWN
	zpomal_1	BIT	0FH	;0/	 ------------//----------
	shift_bit	BIT	10H	;0\	 priznak indikujici,ze navolena fce jsou realne hodiny a je mozno provest misto NULL ->SHIFT
	uloz_bit	BIT	11H	;0 |	 priznak indikujici pozadavek ulozeni editovanych hodnot
	zpomal_2	BIT	12H	;0 |	 priznak pro testovani zpozdeni v subrutine "ven"
	submenu_bit	BIT	13H	;0 |=22H priznak indikujici ze se nachazim v submenu
	blik_bit1	BIT	14H	;0 |	 priznaky signalizujici pozadavek blikani cifry
	blik_bit2	BIT	15H	;0 |	 --------------//---------
	blik_bit3	BIT	16H	;0 |	 -------------//----------
	blik_bit4	BIT	17H	;0/	 -------------//--------
	cs_rtc		BIT	18H	;0\ 	 chip select RTC
	logo_bit	BIT	19H	;1 |	 priznak pro vstup do loga
	wav_bit		BIT	1AH	;0 |=23H priznak zablokovani volani rutiny dotaz
	wav1_bit	BIT	1BH	;0 |	 vyuzit pri dekompresi PCM
	wav2_bit	BIT     1CH	;0 |	 vyuzit pro volani "dotaz" pri zmene funkce
	wav3_bit	BIT     1DH	;0 |	 priznak pro volani druhe casti zpravy ve slozenych dotazech (realny-provozni cas ap.)
	logo1_bit	BIT     1EH	;0 |	 priznak pro test,zda spustit uvodni zpravu(nastaven nebo nulovan v zavislosti na shodnosti data dne)		
	pom1_bit	BIT	1FH	;0/ 	 u verze 1.2 vyuzit pro deleni dvema u rutiny mereni rychlosti a drahy kvuli dvema impulsum misto jednoho na 1 metr
	err_bit		BIT	20H	;je-li tento bit nastaven,doslo k preteceni udaje provozniho casu
				;!!! Tento bit po resetu nenastavovat !!!
	nul_pal		BIT	21H	;preteceni casovace pro palivo (prilis nizka spotreba), kdyz je nastaven zobrazuje se nula
	uloz1_bit	BIT	22H	;pri nastaveni (nastaven pred provedenim vypoctu) neukladej v prubehu vypoctu do jeho promennych
	uloz2_bit	BIT	23H	;totez jako uloz1_bit
	uloz3_bit	BIT	24H	;totez jako uloz1_bit

;-------------Obsazeni registru - banka 1-------------
;	R0.......adresy vnejsich periferii
;	R1.......dis nebo dis_1 - byte ktere maji byt momentalne vycteny programem displej
;	R2.......vyuzit pri vymaskovani jednotlivych cifer na displej
;	R3.......software citac pro citani vstupu do INT od RTC (cita pocet volani,=1s proved rutinu)
;	R4.......casovani tlacitek UP/DOWN,casovani loga
;	R5.......casovani loga
;	R6.......univerzal-v odectu BCD,zpozdovaci smycka pro rychle rutiny
;	R7.......zpozdovaci smycka pro rychle rutiny

